// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// AccountGetRecentEmojiStatusesRequest represents TL type `account.getRecentEmojiStatuses#f578105`.
//
// See https://core.telegram.org/method/account.getRecentEmojiStatuses for reference.
type AccountGetRecentEmojiStatusesRequest struct {
	// Hash field of AccountGetRecentEmojiStatusesRequest.
	Hash int64
}

// AccountGetRecentEmojiStatusesRequestTypeID is TL type id of AccountGetRecentEmojiStatusesRequest.
const AccountGetRecentEmojiStatusesRequestTypeID = 0xf578105

// Ensuring interfaces in compile-time for AccountGetRecentEmojiStatusesRequest.
var (
	_ bin.Encoder     = &AccountGetRecentEmojiStatusesRequest{}
	_ bin.Decoder     = &AccountGetRecentEmojiStatusesRequest{}
	_ bin.BareEncoder = &AccountGetRecentEmojiStatusesRequest{}
	_ bin.BareDecoder = &AccountGetRecentEmojiStatusesRequest{}
)

func (g *AccountGetRecentEmojiStatusesRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.Hash == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *AccountGetRecentEmojiStatusesRequest) String() string {
	if g == nil {
		return "AccountGetRecentEmojiStatusesRequest(nil)"
	}
	type Alias AccountGetRecentEmojiStatusesRequest
	return fmt.Sprintf("AccountGetRecentEmojiStatusesRequest%+v", Alias(*g))
}

// FillFrom fills AccountGetRecentEmojiStatusesRequest from given interface.
func (g *AccountGetRecentEmojiStatusesRequest) FillFrom(from interface {
	GetHash() (value int64)
}) {
	g.Hash = from.GetHash()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*AccountGetRecentEmojiStatusesRequest) TypeID() uint32 {
	return AccountGetRecentEmojiStatusesRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*AccountGetRecentEmojiStatusesRequest) TypeName() string {
	return "account.getRecentEmojiStatuses"
}

// TypeInfo returns info about TL type.
func (g *AccountGetRecentEmojiStatusesRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "account.getRecentEmojiStatuses",
		ID:   AccountGetRecentEmojiStatusesRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Hash",
			SchemaName: "hash",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *AccountGetRecentEmojiStatusesRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode account.getRecentEmojiStatuses#f578105 as nil")
	}
	b.PutID(AccountGetRecentEmojiStatusesRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *AccountGetRecentEmojiStatusesRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode account.getRecentEmojiStatuses#f578105 as nil")
	}
	b.PutLong(g.Hash)
	return nil
}

// Decode implements bin.Decoder.
func (g *AccountGetRecentEmojiStatusesRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode account.getRecentEmojiStatuses#f578105 to nil")
	}
	if err := b.ConsumeID(AccountGetRecentEmojiStatusesRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode account.getRecentEmojiStatuses#f578105: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *AccountGetRecentEmojiStatusesRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode account.getRecentEmojiStatuses#f578105 to nil")
	}
	{
		value, err := b.Long()
		if err != nil {
			return fmt.Errorf("unable to decode account.getRecentEmojiStatuses#f578105: field hash: %w", err)
		}
		g.Hash = value
	}
	return nil
}

// GetHash returns value of Hash field.
func (g *AccountGetRecentEmojiStatusesRequest) GetHash() (value int64) {
	if g == nil {
		return
	}
	return g.Hash
}

// AccountGetRecentEmojiStatuses invokes method account.getRecentEmojiStatuses#f578105 returning error if any.
//
// See https://core.telegram.org/method/account.getRecentEmojiStatuses for reference.
func (c *Client) AccountGetRecentEmojiStatuses(ctx context.Context, hash int64) (AccountEmojiStatusesClass, error) {
	var result AccountEmojiStatusesBox

	request := &AccountGetRecentEmojiStatusesRequest{
		Hash: hash,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.EmojiStatuses, nil
}
